# src/Interfaces/IpStdCInterface.h File Reference

`#include "IpReturnCodes.h"`

Go to the source code of this file.

## Defines
#define | TRUE (1)
#define | FALSE (0)
## Typedefs
typedef double | Number
| Type for all number.
typedef int | Index
| Type for all incides.
typedef int | Int
| Type for all integers.
typedef struct IpoptProblemInfo * | IpoptProblem
| Pointer to a Ipopt Problem.
typedef int | Bool
| define a boolean type for C
typedef void * | UserDataPtr
| A pointer for anything that is to be passed between the called and individual callback function.
typedef Bool(* | Eval_F_CB )(Index n, Number *x, Bool new_x, Number *obj_value, UserDataPtr user_data)
| Type defining the callback function for evaluating the value of the objective function.
typedef Bool(* | Eval_Grad_F_CB )(Index n, Number *x, Bool new_x, Number *grad_f, UserDataPtr user_data)
| Type defining the callback function for evaluating the gradient of the objective function.
typedef Bool(* | Eval_G_CB )(Index n, Number *x, Bool new_x, Index m, Number *g, UserDataPtr user_data)
| Type defining the callback function for evaluating the value of the constraint functions.
typedef Bool(* | Eval_Jac_G_CB )(Index n, Number *x, Bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values, UserDataPtr user_data)
| Type defining the callback function for evaluating the Jacobian of the constrant functions.
typedef Bool(* | Eval_H_CB )(Index n, Number *x, Bool new_x, Number obj_factor, Index m, Number *lambda, Bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values, UserDataPtr user_data)
| Type defining the callback function for evaluating the Hessian of the Lagrangian function.
typedef Bool(* | Intermediate_CB )(Index alg_mod, Index iter_count, Number obj_value, Number inf_pr, Number inf_du, Number mu, Number d_norm, Number regularization_size, Number alpha_du, Number alpha_pr, Index ls_trials, UserDataPtr user_data)
| Type defining the callback function for giving intermediate execution control to the user.
## Functions
| IPOPT_EXPORT (IpoptProblem) CreateIpoptProblem(Index n
| Function for creating a new Ipopt Problem object.
| IPOPT_EXPORT (void) FreeIpoptProblem(IpoptProblem ipopt_problem)
| Method for freeing a previously created IpoptProblem.
| IPOPT_EXPORT (Bool) AddIpoptStrOption(IpoptProblem ipopt_problem
| Function for adding a string option.
| IPOPT_EXPORT (enum ApplicationReturnStatus) IpoptSolve(IpoptProblem ipopt_problem
| Function calling the Ipopt optimization algorithm for a problem previously defined with CreateIpoptProblem.
## Variables
Number * | x_L
| Lower bounds on variables.
Number Number * | x_U
| Upper bounds on variables.
Number Number Index | m
| Number of constraints.
Number Number Index Number * | g_L
| Lower bounds on constraints.
Number Number Index Number Number * | g_U
| Upper bounds on constraints.
Number Number Index Number Number Index | nele_jac
| Number of non-zero elements in constraint Jacobian.
Number Number Index Number Number Index Index | nele_hess
| Number of non-zero elements in Hessian of Lagrangian.
Number Number Index Number Number Index Index Index | index_style
| indexing style for iRow & jCol, 0 for C style, 1 for Fortran style
Number Number Index Number Number Index Index Index Eval_F_CB | eval_f
| Callback function for evaluating objective function.
Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB | eval_g
| Callback function for evaluating constraint functions.
Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB | eval_grad_f
| Callback function for evaluating gradient of objective function.
Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB Eval_Jac_G_CB | eval_jac_g
| Callback function for evaluating Jacobian of constraint functions.
Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB Eval_Jac_G_CB Eval_H_CB | eval_h
| Callback function for evaluating Hessian of Lagrangian function.
char * | keyword
char char * | val
char * | file_name
char Int | print_level
Number | obj_scaling
Number Number * | x_scaling
Number Number Number * | g_scaling
Intermediate_CB | intermediate_cb
Number * | x
| Input: Starting point Output: Optimal solution.
Number Number * | g
| Values of constraint at final point (output only - ignored if set to NULL).
Number Number Number * | obj_val
| Final value of objective function (output only - ignored if set to NULL).
Number Number Number Number * | mult_g
| Input: Initial values for the constraint multipliers (only if warm start option is chosen) Output: Final multipliers for constraints (ignored if set to NULL).
Number Number Number Number Number * | mult_x_L
| Input: Initial values for the multipliers for lower variable bounds (only if warm start option is chosen) Output: Final multipliers for lower variable bounds (ignored if set to NULL).
Number Number Number Number Number Number * | mult_x_U
| Input: Initial values for the multipliers for upper variable bounds (only if warm start option is chosen) Output: Final multipliers for upper variable bounds (ignored if set to NULL).
Number Number Number Number Number Number UserDataPtr | user_data
| Pointer to user data.

## Define Documentation

#define TRUE (1)

Definition at line 57 of file IpStdCInterface.h.

#define FALSE (0)

Definition at line 60 of file IpStdCInterface.h.

## Typedef Documentation

typedef double Number

Type for all number.

We need to make sure that this is identical with what is defined in Common/IpTypes.hpp

Definition at line 33 of file IpStdCInterface.h.

typedef int Index

Type for all incides.

We need to make sure that this is identical with what is defined in Common/IpTypes.hpp

Definition at line 37 of file IpStdCInterface.h.

typedef int Int

Type for all integers.

We need to make sure that this is identical with what is defined in Common/IpTypes.hpp

Definition at line 41 of file IpStdCInterface.h.

typedef struct IpoptProblemInfo* IpoptProblem

Pointer to a Ipopt Problem.

Definition at line 52 of file IpStdCInterface.h.

typedef int Bool

define a boolean type for C

Definition at line 55 of file IpStdCInterface.h.

typedef void* UserDataPtr

A pointer for anything that is to be passed between the called and individual callback function.

Definition at line 65 of file IpStdCInterface.h.

typedef Bool(* Eval_F_CB)(Index n, Number *x, Bool new_x, Number *obj_value, UserDataPtr user_data)

Type defining the callback function for evaluating the value of the objective function.

Return value should be set to false if there was a problem doing the evaluation.

Definition at line 70 of file IpStdCInterface.h.

typedef Bool(* Eval_Grad_F_CB)(Index n, Number *x, Bool new_x, Number *grad_f, UserDataPtr user_data)

Type defining the callback function for evaluating the gradient of the objective function.

Return value should be set to false if there was a problem doing the evaluation.

Definition at line 76 of file IpStdCInterface.h.

typedef Bool(* Eval_G_CB)(Index n, Number *x, Bool new_x, Index m, Number *g, UserDataPtr user_data)

Type defining the callback function for evaluating the value of the constraint functions.

Return value should be set to false if there was a problem doing the evaluation.

Definition at line 82 of file IpStdCInterface.h.

typedef Bool(* Eval_Jac_G_CB)(Index n, Number *x, Bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values, UserDataPtr user_data)

Type defining the callback function for evaluating the Jacobian of the constrant functions.

Return value should be set to false if there was a problem doing the evaluation.

Definition at line 88 of file IpStdCInterface.h.

typedef Bool(* Eval_H_CB)(Index n, Number *x, Bool new_x, Number obj_factor, Index m, Number *lambda, Bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values, UserDataPtr user_data)

Type defining the callback function for evaluating the Hessian of the Lagrangian function.

Return value should be set to false if there was a problem doing the evaluation.

Definition at line 96 of file IpStdCInterface.h.

typedef Bool(* Intermediate_CB)(Index alg_mod,Index iter_count, Number obj_value, Number inf_pr, Number inf_du, Number mu, Number d_norm, Number regularization_size, Number alpha_du, Number alpha_pr, Index ls_trials, UserDataPtr user_data)

Type defining the callback function for giving intermediate execution control to the user.

If set, it is called once per iteration, providing the user with some information on the state of the optimization. This can be used to print some user-defined output. It also gives the user a way to terminate the optimization prematurely. If this method returns false, Ipopt will terminate the optimization.

Definition at line 108 of file IpStdCInterface.h.

## Function Documentation

IPOPT_EXPORT | ( | IpoptProblem |  | ) |

Function for creating a new Ipopt Problem object.

This function returns an object that can be passed to the IpoptSolve call. It contains the basic definition of the optimization problem, such as number of variables and constraints, bounds on variables and constraints, information about the derivatives, and the callback function for the computation of the optimization problem functions and derivatives. During this call, the options file PARAMS.DAT is read as well.

If NULL is returned, there was a problem with one of the inputs or reading the options file. Number of optimization variables

IPOPT_EXPORT | ( | void |  | ) |

Method for freeing a previously created IpoptProblem.

After freeing an IpoptProblem, it cannot be used anymore.

IPOPT_EXPORT | ( | Bool |  | ) |

Function for adding a string option.

Setting a callback function for the "intermediate callback" method in the TNLP.

Optional function for setting scaling parameter for the NLP.

Function for opening an output file for a given name with given printlevel.

Function for adding an Int option.

Function for adding a Number option.

Returns FALSE the option could not be set (e.g., if keyword is unknown)

Returns false, if there was a problem opening the file.

This corresponds to the get_scaling_parameters method in TNLP. If the pointers x_scaling or g_scaling are NULL, then no scaling for x resp. g is done.

This gives control back to the user once per iteration. If set, it provides the user with some information on the state of the optimization. This can be used to print some user-defined output. It also gives the user a way to terminate the optimization prematurely. If the callback method returns false, Ipopt will terminate the optimization. Calling this set method to set the CB pointer to NULL disables the intermediate callback functionality.

IPOPT_EXPORT | ( | enum | ApplicationReturnStatus | ) |

Function calling the Ipopt optimization algorithm for a problem previously defined with CreateIpoptProblem.

The return specified outcome of the optimization procedure (e.g., success, failure etc). Problem that is to be optimized. Ipopt will use the options previously specified with AddIpoptOption (etc) for this problem.

## Variable Documentation

Number* x_L

Lower bounds on variables.

This array of size n is copied internally, so that the caller can change the incoming data after return without that IpoptProblem is modified. Any value less or equal than the number specified by option 'nlp_lower_bound_inf' is interpreted to be minus infinity.

Definition at line 137 of file IpStdCInterface.h.

Number Number* x_U

Upper bounds on variables.

This array of size n is copied internally, so that the caller can change the incoming data after return without that IpoptProblem is modified. Any value greater or equal than the number specified by option 'nlp_upper_bound_inf' is interpreted to be plus infinity.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index m

Number of constraints.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number* g_L

Lower bounds on constraints.

This array of size m is copied internally, so that the caller can change the incoming data after return without that IpoptProblem is modified. Any value less or equal than the number specified by option 'nlp_lower_bound_inf' is interpreted to be minus infinity.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number* g_U

Upper bounds on constraints.

This array of size m is copied internally, so that the caller can change the incoming data after return without that IpoptProblem is modified. Any value greater or equal than the number specified by option 'nlp_upper_bound_inf' is interpreted to be plus infinity.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index nele_jac

Number of non-zero elements in constraint Jacobian.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index nele_hess

Number of non-zero elements in Hessian of Lagrangian.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index index_style

indexing style for iRow & jCol, 0 for C style, 1 for Fortran style

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index Eval_F_CB eval_f

Callback function for evaluating objective function.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB eval_g

Callback function for evaluating constraint functions.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB eval_grad_f

Callback function for evaluating gradient of objective function.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB Eval_Jac_G_CB eval_jac_g

Callback function for evaluating Jacobian of constraint functions.

Definition at line 137 of file IpStdCInterface.h.

Number Number Index Number Number Index Index Index Eval_F_CB Eval_G_CB Eval_Grad_F_CB Eval_Jac_G_CB Eval_H_CB eval_h

Callback function for evaluating Hessian of Lagrangian function.

Definition at line 137 of file IpStdCInterface.h.

char * keyword

Definition at line 189 of file IpStdCInterface.h.

char Int val

Definition at line 189 of file IpStdCInterface.h.

char* file_name

Definition at line 202 of file IpStdCInterface.h.

char Int print_level

Definition at line 202 of file IpStdCInterface.h.

Number obj_scaling

Definition at line 210 of file IpStdCInterface.h.

Number Number* x_scaling

Definition at line 210 of file IpStdCInterface.h.

Number Number Number* g_scaling

Definition at line 210 of file IpStdCInterface.h.

Intermediate_CB intermediate_cb

Definition at line 224 of file IpStdCInterface.h.

Number* x

Input: Starting point Output: Optimal solution.

Definition at line 238 of file IpStdCInterface.h.

Number Number* g

Values of constraint at final point (output only - ignored if set to NULL).

Definition at line 238 of file IpStdCInterface.h.

Number Number Number* obj_val

Final value of objective function (output only - ignored if set to NULL).

Definition at line 238 of file IpStdCInterface.h.

Number Number Number Number* mult_g

Input: Initial values for the constraint multipliers (only if warm start option is chosen) Output: Final multipliers for constraints (ignored if set to NULL).

Definition at line 238 of file IpStdCInterface.h.

Number Number Number Number Number* mult_x_L

Input: Initial values for the multipliers for lower variable bounds (only if warm start option is chosen) Output: Final multipliers for lower variable bounds (ignored if set to NULL).

Definition at line 238 of file IpStdCInterface.h.

Number Number Number Number Number Number* mult_x_U

Input: Initial values for the multipliers for upper variable bounds (only if warm start option is chosen) Output: Final multipliers for upper variable bounds (ignored if set to NULL).

Definition at line 238 of file IpStdCInterface.h.

Number Number Number Number Number Number UserDataPtr user_data

Pointer to user data.

This will be passed unmodified to the callback functions.

Definition at line 238 of file IpStdCInterface.h.

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines